!-----------------------------------------------------------------------!
!                                                                       !
!                                                                       !
!                      Algorithmes de descente                          !
!                                                                       !
!                                                                       !
!-----------------------------------------------------------------------!

module M_Descente
  use M_func
  use M_types
  implicit none
contains
  subroutine Descente(Data)
    type(Donnees),intent(in)       ::Data
    !variables locale
    real                           ::f
    real,dimension(Data%Ndim)      ::xk

    print*,"valeur du minimum"
    call func(xk,f,Data)
    print*,f

    140 format(13(e25.16,1x))!format(9(e18.6,1x))

  end subroutine Descente

!-----------------------------------------------------------------------!
!                                                                       !
!                                                                       !
!                      Recherche lineaire de pas                        !
!                                                                       !
!                                                                       !
!-----------------------------------------------------------------------!

!****************************
!Methode de Goldstein
!****************************

  subroutine Goldstein(x,alpha,dk,Data)
    type(Donnees)               ::Data
    real,dimension(data%ndim)   ::x,dk
    real                        ::alpha
 
  end subroutine Goldstein

!****************************
!Methode de Wolfe-Powell
!****************************

  subroutine WolfePowell(x,alpha,dk,Data)
    type(Donnees)               ::Data
    real,dimension(data%ndim)   ::x,dk
    real                        ::alpha 
    !variables locales
 
  end subroutine WolfePowell

!****************************
!Gradient conjugue
!****************************

  subroutine GradConjugue(x,Data)
    type(Donnees)               ::Data
    real,dimension(data%ndim)   ::x


  end subroutine GradConjugue


!-----------------------------------------------------------------------!
!                                                                       !
!                                                                       !
!                      Calcul du gradient de f                          !
!                                                                       !
!                                                                       !
!-----------------------------------------------------------------------!

  subroutine Gradientf(point,gradient,Data)
    type(Donnees),intent(in)    ::Data
    real,dimension(Data%Ndim)   ::point,gradient
    real                        ::epsilon
 
    
  end subroutine Gradientf
end module M_Descente
